Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Public Attributes

# Packager.Package Class Reference

List of all members.

## Public Member Functions
def | __init__
def | addBamFile
def | addComponent
def | addDcFile
def | addDcImports
def | addEggFile
def | addExtensionModules
def | addFile
def | addFoundTexture
def | addNode
def | addPrcFile
def | addPyFile
def | cleanup
def | close
def | compressMultifile
def | considerPlatform
def | excludeFile
def | getFileSpec
def | installMultifile
def | installSolo
def | makeP3dInfo
def | readDescFile
def | readImportDescFile
def | requirePackage
def | writeDescFile
def | writeImportDescFile
## Public Attributes
| arch
| components
| compressionLevel
| configs
| excludedFilenames
| extracts
| files
| freezer
| host
| importedMapsDir
| mainModule
| moduleNames
| multifile
| notify
| oldCompressedBasename
| p3dApplication
| packageBasename
| packageDesc
| packageDir
| packageFilename
| packageFullpath
| packageImportDesc
| packageName
| packager
| packageSeq
| packageSetVer
| patches
| patchVersion
| platform
| platformSpecificConfig
| requiredFilenames
| requiredModules
| requires
| signParams
| skipFilenames
| skipModules
| solo
| sourceFilenames
| targetFilenames
| version

## Detailed Description

    This is the full information on a particular package we
    are constructing.  Don't confuse it with PackageEntry, above,
    which contains only the information found in the toplevel
    contents.xml file.

## Constructor & Destructor Documentation

def __init__ | ( |  | self,
|  |  | packageName,
|  |  | packager
| ) |  |

## Member Function Documentation

def addBamFile | ( |  | self,
|  |  | file
| ) |  |

def addComponent | ( |  | self,
|  |  | file
| ) |  |

def addDcFile | ( |  | self,
|  |  | file
| ) |  |

    Adds a dc file to the archive.  A dc file gets its
    internal comments and parameter names stripped out of the
    final result automatically.  This is as close as we can
    come to "compiling" a dc file, since all of the remaining
    symbols are meaningful at runtime.

def addDcImports | ( |  | self,
|  |  | file
| ) |  |

    Adds the Python modules named by the indicated dc
    file.

def addEggFile | ( |  | self,
|  |  | file
| ) |  |

def addExtensionModules | ( |  | self | ) |

    Adds the extension modules detected by the freezer to
    the current list of files.

def addFile | ( |  | self,
|  |  | args,
|  |  | kw
| ) |  |

    Adds the named file to the package.  Returns the file
    object, or None if it was not added by this call.

def addFoundTexture | ( |  | self,
|  |  | filename
| ) |  |

    Adds the newly-discovered texture to the output, if it has
    not already been included.  Returns the new name within the
    package tree.

def addNode | ( |  | self,
|  |  | node,
|  |  | filename,
|  |  | newName
| ) |  |

    Converts the indicated node to a bam stream, and adds the
    bam file to the multifile under the indicated newName.

def addPrcFile | ( |  | self,
|  |  | file
| ) |  |

    Adds a prc file to the archive.  Like the dc file,
    this strips comments and such before adding.  It's also
    possible to set prcEncryptionKey and/or prcSignCommand to
    further manipulate prc files during processing.

def addPyFile | ( |  | self,
|  |  | file
| ) |  |

    Adds the indicated python file, identified by filename
    instead of by module name, to the package.

def cleanup | ( |  | self | ) |

def close | ( |  | self | ) |

    Writes out the contents of the current package.  Returns True
    if the package was constructed successfully, False if one or more
    required files or modules are missing.

def compressMultifile | ( |  | self | ) |

    Compresses the .mf file into an .mf.pz file.

def considerPlatform | ( |  | self | ) |

def excludeFile | ( |  | self,
|  |  | filename
| ) |  |

    Excludes the named file (or glob pattern) from the
    package.

def getFileSpec | ( |  | self,
|  |  | element,
|  |  | pathname,
|  |  | newName
| ) |  |

    Returns an xcomponent or similar element with the file
    information for the indicated file.

def installMultifile | ( |  | self | ) |

    Installs the package, either as a p3d application, or
    as a true package.  Either is implemented with a
    Multifile.

def installSolo | ( |  | self | ) |

    Installs the package as a "solo", which means we
    simply copy the one file into the install directory.  This
    is primarily intended for the "coreapi" plugin, which is
    just a single dll and a jpg file; but it can support other
    kinds of similar "solo" packages as well.

def makeP3dInfo | ( |  | self | ) |

    Makes the p3d_info.xml file that defines the
    application startup parameters and such.

def readDescFile | ( |  | self | ) |

    Reads the existing package.xml file before rewriting
    it.  We need this to preserve the list of patches, and
    similar historic data, between sessions.

def readImportDescFile | ( |  | self,
|  |  | filename
| ) |  |

    Reads the import desc file.  Returns True on success,
    False on failure.

def requirePackage | ( |  | self,
|  |  | package
| ) |  |

    Indicates a dependency on the given package.  This
    also implicitly requires all of the package's requirements
    as well (though this transitive requirement happens at
    runtime, not here at build time).

def writeDescFile | ( |  | self | ) |

    Makes the package.xml file that describes the package
    and its contents, for download.

def writeImportDescFile | ( |  | self | ) |

    Makes the package.import.xml file that describes the
    package and its contents, for other packages and
    applications that may wish to "require" this one.

## Member Data Documentation

arch

components

compressionLevel

configs

excludedFilenames

extracts

files

freezer

host

importedMapsDir

mainModule

moduleNames

multifile

notify

oldCompressedBasename

p3dApplication

packageBasename

packageDesc

packageDir

packageFilename

packageFullpath

packageImportDesc

packageName

packager

packageSeq

packageSetVer

patches

patchVersion

platform

platformSpecificConfig

requiredFilenames

requiredModules

requires

signParams

skipFilenames

skipModules

solo

sourceFilenames

targetFilenames

version

All Classes Namespaces Functions Variables Enumerations Enumerator Properties